#include "command.h"
#include "clientprot.h"


//////// Commands ////////

void gotHelp(Host * h, Player * p, Command * c)
{
	if (c->checkParam(""))
	{
		switch (p->access)
		{
		case OP_Owner:
			{
				h->sendPrivate(p, "MERVBot Owner commandlist");
				h->sendPrivate(p, " !password close closeall autosave save read set");
				h->sendPrivate(p, " !spawn go capslock error autokick denyprize get");
				h->sendPrivate(p, " !addop removeop zone say autoship autospec denyanti");
				h->sendPrivate(p, " !ballnotify jackpotnotify flagnotify eventeams");
				h->sendPrivate(p, " !listop setlogin ver info autoprize killprize");
			}
			break;
		case OP_SysOp:
			{
				h->sendPrivate(p, "MERVBot SysOp commandlist");
				h->sendPrivate(p, " !spawn go close capslock error autokick autospec");
				h->sendPrivate(p, " !addop removeop say denyprize denyanti eventeams");
				h->sendPrivate(p, " !setlogin ver ballnotify jackpotnotify flagnotify");
				h->sendPrivate(p, " !listop autoprize killprize zone autoship");
			}
			break;
		case OP_SuperModerator:
			{
				h->sendPrivate(p, "MERVBot SuperModerator commandlist");
				h->sendPrivate(p, " !addop removeop say killprize autoprize");
				h->sendPrivate(p, " !setlogin eventeams autospec autoship zone");
				h->sendPrivate(p, " !listop ver ballnotify jackpotnotify flagnotify");
			}
			break;
		case OP_Moderator:
			{
				h->sendPrivate(p, "MERVBot Moderator commandlist");
				h->sendPrivate(p, " !setlogin zone ballnotify jackpotnotify flagnotify killprize");
				h->sendPrivate(p, " !listop say eventeams autospec autoship autoprize version");
			}
			break;
		case OP_Player:
			{
				h->sendPrivate(p, "Commands: !help !listop !sex !login");
			}
			break;
		};
	}

	switch (p->access)
	{
	case OP_Owner:
		if (c->checkParam("password"))
		{
			h->sendPrivate(p, "!password [bot password] (change or view bot password)");
		}
		else if (c->checkParam("info"))
		{
			h->sendPrivate(p, "!info (describe bot state)");
		}
		else if (c->checkParam("closeall"))
		{
			h->sendPrivate(p, "!closeall (close all bot spawns)");
		}
		else if (c->checkParam("autosave"))
		{
			h->sendPrivate(p, "!autosave -i [on/off] (save database on a timer)");
			h->sendPrivate(p, "          -i=time (set interval in minutes)");
		}
		else if (c->checkParam("save"))
		{
			h->sendPrivate(p, "!save (manually save database)");
		}
		else if (c->checkParam("read"))
		{
			h->sendPrivate(p, "!read (manually re-read INI)");
		}
		else if (c->checkParam("set"))
		{
			h->sendPrivate(p, "!set <section>:<key>:<new value> (change INI key)");
		}
		else if (c->checkParam("get"))
		{
			h->sendPrivate(p, "!get <section>:<key> (retrieve INI key)");
		}

	case OP_SysOp:
		if (c->checkParam("spawn") || c->checkParam("respawn"))
		{
			h->sendPrivate(p, "!spawn -zat <bot name> (create a new bot)");
			h->sendPrivate(p, "       -z=zone (set bot zone)");
			h->sendPrivate(p, "       -a=arena (set bot arena)");
			h->sendPrivate(p, "       -t=type (set bot type)");
		}
		else if (c->checkParam("go"))
		{
			h->sendPrivate(p, "!go [@/#]<arena name> (change bot's arena)");
			h->sendPrivate(p, "    @ (specific public arena)");
			h->sendPrivate(p, "    # (secret arena)");
		}
		else if (c->checkParam("close"))
		{
			h->sendPrivate(p, "!close [bot name] (close a bot spawn)");
		}
		else if (c->checkParam("error"))
		{
			h->sendPrivate(p, "!error -c [on/off] (change error broadcast channel)");
			h->sendPrivate(p, "       -c=channel (set channels)");
		}
		else if (c->checkParam("capslock"))
		{
			h->sendPrivate(p, "!capslock -l [on/off] (capslock check)");
			h->sendPrivate(p, "          -l=length (set message length)");
		}
		else if (c->checkParam("autokick"))
		{
			h->sendPrivate(p, "!autokick -dingfozm [on/off] (capslock check)");
			h->sendPrivate(p, "          -d (illegal deaths)");
			h->sendPrivate(p, "          -i (machine ident)");
			h->sendPrivate(p, "          -n (names)");
			h->sendPrivate(p, "          -g (unavailable greens)");
			h->sendPrivate(p, "          -f=green factor (X times normal distribution)");
			h->sendPrivate(p, "          -o=warnings (warnings before kick)");
			h->sendPrivate(p, "          -z (timezone)");
			h->sendPrivate(p, "          -m=limit (max mines over limit)");
		}
		else if (c->checkParam("denyprize"))
		{
			h->sendPrivate(p, "!denyprize -bmp [on/off] (disallow prizes to certain ships)");
			h->sendPrivate(p, "           -b=1,2,3 (bouncing bullets)");
			h->sendPrivate(p, "           -m=ship list (multifire bullets)");
			h->sendPrivate(p, "           -p=ship list (proximity bombs)");
		}
		else if (c->checkParam("denyanti"))
		{
			h->sendPrivate(p, "!denyanti -trl [on/off] (capslock check)");
			h->sendPrivate(p, "          -t=time (time before triggering)");
			h->sendPrivate(p, "          -r=radius (circular area, distance from center in tiles)");
			h->sendPrivate(p, "          -l=length (square area, side length in tiles)");
		}

	case OP_SuperModerator:
		if (c->checkParam("createop") || c->checkParam("addop") || c->checkParam("op"))
		{
			h->sendPrivate(p, "!op -lp <name> (create a new operator)");
			h->sendPrivate(p, "    -l=level (set operator level, Moderator by default)");
			h->sendPrivate(p, "    -p=password (set password, unassigned by default)");
		}
		else if (c->checkParam("killop") || c->checkParam("deleteop") || c->checkParam("removeop") || c->checkParam("dop"))
		{
			h->sendPrivate(p, "!dop <name> (remove operator status)");
		}

	case OP_Moderator:
		if (c->checkParam("setlogin"))
		{
			h->sendPrivate(p, "!setlogin <new password> (change personal login)");
		}
		else if (c->checkParam("ver") || c->checkParam("version"))
		{
			h->sendPrivate(p, "!ver (display bot version)");
		}
		else if (c->checkParam("ballnotify"))
		{
			h->sendPrivate(p, "!ballnotify -pt [on/off] (notify of powerball position)");
			h->sendPrivate(p, "            -p (when pball changes player owner)");
			h->sendPrivate(p, "            -t (when pball changes team owner)");
		}
		else if (c->checkParam("say"))
		{
			h->sendPrivate(p, "!say <message> (make the bot say something)");
		}
		else if (c->checkParam("jackpotnotify"))
		{
			h->sendPrivate(p, "!jackpotnotify -p [on/off] (notify of jackpot change)");
			h->sendPrivate(p, "               -p (change in points between broadcasts)");
		}
		else if (c->checkParam("flagnotify"))
		{
			h->sendPrivate(p, "!flagnotify -i [on/off] (notify of flag coordinates)");
			h->sendPrivate(p, "            -i (time between broadcasts)");
		}
		else if (c->checkParam("eventeams"))
		{
			h->sendPrivate(p, "!eventeams -v [on/off] (keep teams even)");
			h->sendPrivate(p, "           -v (variance in teams before triggering)");
		}
		else if (c->checkParam("autospec"))
		{
			h->sendPrivate(p, "!autospec -d [on/off] (spec after a number of deaths)");
			h->sendPrivate(p, "          -d (death count)");
		}
		else if (c->checkParam("autoship"))
		{
			h->sendPrivate(p, "!autoship -s [on/off] (keep players in one kind of ship)");
			h->sendPrivate(p, "          -s (ship type)");
		}
		else if (c->checkParam("autoprize"))
		{
			h->sendPrivate(p, "!autoprize -pt [on/off] (periodic prizes)");
			h->sendPrivate(p, "           -p (prize type)");
			h->sendPrivate(p, "           -t (time between prizings)");
		}
		else if (c->checkParam("zone") || c->checkParam("advertise"))
		{
			h->sendPrivate(p, "!zone/!advertise <message> (broadcast message zone-wide)");
		}
		else if (c->checkParam("killprize"))
		{
			h->sendPrivate(p, "!killprize -p [on/off] (prize reward after a kill)");
			h->sendPrivate(p, "           -p (prize type)");
		}

	case OP_Player:
		if (c->checkParam("help"))
		{
			h->sendPrivate(p, "!help [topic] (display available commands and what they do)");
		}
		else if (c->checkParam("unf") || c->checkParam("sex"))
		{
			h->sendPrivate(p, "!sex (have sex with bot)");
		}
		else if (c->checkParam("listop"))
		{
			h->sendPrivate(p, "!listop -o (list online operators)");
			h->sendPrivate(p, "        -o (offline also)");
		}
		else if (c->checkParam("login"))
		{
			h->sendPrivate(p, "!login <password> (grant self operator status)");
		}
	};
}

void gotCommand(Host * h, Player * p, char * m)
{
	Command c(m, h);

	switch (p->access)
	{
	case OP_Owner:
		if (c.check("password"))
		{
			if (c.checkParam(""))
			{
				h->sendPrivate(p, "Retrieve password");
			}
			else
			{
				h->sendPrivate(p, "Set password");
			}
		}
		else if (c.check("info"))
		{
			h->sendPrivate(p, "Bot information");
		}
		else if (c.check("closeall"))
		{
			h->sendPrivate(p, "Close all bots");
		}
		else if (c.check("autosave"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Autosave on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Autosave off");
			}

			if (c.getParam('i'))
			{
				h->sendPrivate(p, "Autosave interval changed");
			}
		}
		else if (c.check("save"))
		{
			h->sendPrivate(p, "Save database");
		}
		else if (c.check("read"))
		{
			h->sendPrivate(p, "Read INI");
		}
		else if (c.check("set"))
		{
			h->sendPrivate(p, "Set INI variable");
		}
		else if (c.check("get"))
		{
			h->sendPrivate(p, "Get INI variable");
		}

	case OP_SysOp:
		if (c.check("spawn") || c.check("respawn"))
		{
			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Spawn with given password");
			}
			else
			{
				h->sendPrivate(p, "Spawn with default password");
			}

			if (c.getParam('t'))
			{
				h->sendPrivate(p, "Setting bot type");
			}

			if (c.getParam('z'))
			{
				h->sendPrivate(p, "Setting bot zone");
			}

			if (c.getParam('a'))
			{
				h->sendPrivate(p, "Setting bot arena");
			}
		}
		else if (c.check("go"))
		{
			h->sendPrivate(p, "Changing arena");
		}
		else if (c.check("close"))
		{
			h->sendPrivate(p, "Close bot");
		}
		else if (c.check("capslock"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Capslock check on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Capslock check off");
			}

			if (c.getParam('l'))
			{
				h->sendPrivate(p, "Setting message length");
			}

			if (c.getParam('w'))
			{
				h->sendPrivate(p, "Setting warnings");
			}
		}
		else if (c.check("error"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Error broadcast on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Error broadcast off");
			}

			if (c.getParam('c'))
			{
				h->sendPrivate(p, "Setting error channel(s)");
			}
		}
		else if (c.check("autokick"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Autokick on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Autokick off");
			}

			if (c.getParam('n'))
			{
				h->sendPrivate(p, "Illegal name checker enabled");
			}

			if (c.getParam('z'))
			{
				h->sendPrivate(p, "Illegal timezone checker enabled");
			}

			if (c.getParam('i'))
			{
				h->sendPrivate(p, "Illegal machine ident checker enabled");
			}

			if (c.getParam('m'))
			{
				h->sendPrivate(p, "Illegal mine checker enabled");
			}

			if (c.getParam('g'))
			{
				h->sendPrivate(p, "Illegal green checker enabled");
			}

			if (c.getParam('f'))
			{
				h->sendPrivate(p, "Illegal green distribution checker enabled");
			}

			if (c.getParam('d'))
			{
				h->sendPrivate(p, "Illegal death checker enabled");
			}

			if (c.getParam('o'))
			{
				h->sendPrivate(p, "Illegal message checker enabled");
			}
		}
		else if (c.check("denyanti"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Antiwarp check on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Antiwarp check off");
			}

			if (c.getParam('r'))
			{
				h->sendPrivate(p, "Setting circular area radius");
			}
			else if (c.getParam('l'))
			{
				h->sendPrivate(p, "Setting square area length");
			}

			if (c.getParam('t'))
			{
				h->sendPrivate(p, "Setting time before triggering");
			}
		}
		else if (c.check("denyprize"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Deny prize on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Deny prize off");
			}

			if (c.getParam('b'))
			{
				h->sendPrivate(p, "Setting bouncing bullet ships");
			}

			if (c.getParam('m'))
			{
				h->sendPrivate(p, "Setting multifire bullet ships");
			}

			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Setting proximity bomb ships");
			}
		}

	case OP_SuperModerator:
		if (c.check("createop") || c.check("addop") || c.check("op"))
		{
			h->sendPrivate(p, "Creating operator");

			if (c.getParam('l'))
			{
				h->sendPrivate(p, "Setting level");
			}

			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Setting password");
			}
		}
		else if (c.check("changeop") || c.check("editop"))
		{
			h->sendPrivate(p, "Changing operator");

			if (c.getParam('l'))
			{
				h->sendPrivate(p, "Setting level");
			}

			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Setting password");
			}
		}
		else if (c.check("killop") || c.check("deleteop") || c.check("removeop") || c.check("dop"))
		{
			h->sendPrivate(p, "Creating operator");
		}

	case OP_Moderator:
		if (c.check("setlogin"))
		{
			h->sendPrivate(p, "Password changed to");
			h->sendPrivate(p, c.cmd);
		}
		else if (c.check("ver") || c.check("version"))
		{
			h->sendPrivate(p, "MERVBot (Build 1) by Catid@pacbell.net");
		}
		else if (c.check("say"))
		{
			h->sendPrivate(p, "TODO");
		}
		else if (c.check("ballnotify"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Ball notify on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Ball notify off");
			}

			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Ball notify whenever pball changes player");
			}
			else if (c.getParam('t'))
			{
				h->sendPrivate(p, "Ball notify whenever pball changes team");
			}
		}
		else if (c.check("jackpotnotify"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Jackpot notify on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Jackpot notify off");
			}

			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Jackpot point interval changed");
			}
		}
		else if (c.check("flagnotify"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Flag notify on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Flag notify off");
			}

			if (c.getParam('i'))
			{
				h->sendPrivate(p, "Flag time interval changed");
			}
		}
		else if (c.check("eventeams"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Team evening on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Team evening off");
			}

			if (c.getParam('v'))
			{
				h->sendPrivate(p, "Team variance changed");
			}
		}
		else if (c.check("autospec"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Autospec on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Autospec off");
			}

			if (c.getParam('d'))
			{
				h->sendPrivate(p, "Deaths changed");
			}
		}
		else if (c.check("autoship"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Auto ship on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Auto ship off");
			}

			if (c.getParam('s'))
			{
				h->sendPrivate(p, "Ship-type changed");
			}
		}
		else if (c.check("autoprize"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Autoprize on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Autoprize off");
			}

			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Prize changed");
			}
			else if (c.getParam('t'))
			{
				h->sendPrivate(p, "Interim changed");
			}
		}
		else if (c.check("zone") || c.check("advertise"))
		{
			h->sendPrivate(p, c.final);
		}
		else if (c.check("killprize"))
		{
			if (c.checkParam("on"))
			{
				h->sendPrivate(p, "Killprize on");
			}
			else if (c.checkParam("off"))
			{
				h->sendPrivate(p, "Killprize off");
			}

			if (c.getParam('p'))
			{
				h->sendPrivate(p, "Prize changed");
			}
		}

	case OP_Player:
		if (c.check("help"))
		{
			gotHelp(h, p, &c);
		}
		else if (c.check("unf") || c.check("sex"))
		{
			h->sendPrivate(p, SND_Girl, "Unf! Unf! Unf!");
		}
		else if (c.check("listop"))
		{
			_switch * s = c.getParam('o');

			h->sendPrivate(p, "Online ops: TODO");

			if (s)
			{
				h->sendPrivate(p, "Offline ops: TODO");
			}
		}
		else if (c.check("login"))
		{
			_switch * s = c.getParam('l');

			opEntry * op = h->botInfo.db->findOperator(p->name);

			if (op)
			{	// Listed
				if (op->validatePass(c.final))
				{	// 
					p->access = op->getAccess();
					op->addCounter();
					h->sendPrivate(p, "Welcome back. 2 active sessions; 25 accesses since instantiation");
				}
				else
				{	// Bad password
					return;
				}
			}
			else
			{	// Not listed
				return;
			}

			if (s)
			{
				h->sendPrivate(p, s->param);
			}
		}
	};
}
